/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons.test;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;

import org.jcoderz.commons.LogMessageInfoImpl;
import org.jcoderz.commons.BusinessImpact;
import org.jcoderz.commons.Category;
import org.jcoderz.commons.LogEvent;
import org.jcoderz.commons.AuditLogEvent;
import org.jcoderz.commons.Loggable;
import org.jcoderz.commons.AuditPrincipal;

/**
 * Enumeration of all Test Service log messages.
 *
 * <p>Instances of this class are immutable.</p>
 *
 * The following Test Service are defined:
 * <ul>
 *    <li>TssLogMessage.FUNNY_RUNTIME</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS_LOG</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS2</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS_LOG2</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS3</li>
 *    <li>TssLogMessage.IMPLIED_PARAMETERS_LOG3</li>
 * </ul>
 *
 * @author generated
 */
public abstract class TssLogMessage
      extends LogMessageInfoImpl
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   /**
    * Private constructor used by the inner classes.
    * @param symbol The symbolic name of the log message.
    * @param id The unique numeric id of the log message.
    * @param level The log level that is used to log such a message.
    * @param text The detailed text of the log message.
    * @param solution The solution text of the log message.
    * @param businessImpact The business impact of the log message.
    * @param category The category of the log message.
    * @param params The paramter list used in the detailed text.
    * @param appName The application name.
    * @param appNameAbbr The application name abbreviation.
    * @param groupName The group name.
    * @param groupNameAbbr The group name abbreviation.
    */
   private TssLogMessage (String symbol, int id, Level level,
         String text, String solution, BusinessImpact businessImpact,
         Category category, String[] params, String appName, String appNameAbbr,
         String groupName, String groupNameAbbr)
   {
      super(symbol, id, level, text, solution, businessImpact, category, params,
            appName, appNameAbbr, groupName, groupNameAbbr);
   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>FUNNY_RUNTIME</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: Generic technical issue in the caused by '{CAUSE_TEXT}'.</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class FunnyRuntime
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>FUNNY_RUNTIME</code>. */
      public static final int INT_VALUE = 1677787139;
   
      /** The parameter <code>CAUSE_TEXT</code> for the log message text. */
      public static final String PARAM_CAUSE_TEXT
            = "CAUSE_TEXT";
      

      /**
       * The unique symbolic String of the log message
       * <code>FUNNY_RUNTIME</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_FUNNY_RUNTIME";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private FunnyRuntime ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_FUNNY_RUNTIME",
               1677787139,
               
            Level.INFO,
               "Generic technical issue in the caused by '{0}'.",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "CAUSE_TEXT"   // PARAM_CAUSE_TEXT
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @param causeText The cause text used in the message.
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String causeText)
      {
         loggable.addParameter(PARAM_CAUSE_TEXT, causeText);
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParameters
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS</code>. */
      public static final int INT_VALUE = 1677787140;
   
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParameters ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS",
               1677787140,
               
            Level.INFO,
               "This error has the id {0} occured on Thread {1} named {2}. Please note that the nested exception was {3}.",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE"   // PARAM__CAUSE
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable)
      {
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS_LOG</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParametersLog
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS_LOG</code>. */
      public static final int INT_VALUE = 1677787141;
   
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS_LOG</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS_LOG";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParametersLog ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS_LOG",
               1677787141,
               
            Level.INFO,
               "This error has the id {0} occured on Thread {1} named {2}. Please note that the nested exception was {3}.",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE"   // PARAM__CAUSE
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      
      /**
       * Logs the message
       * <tt>"This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}."</tt>
       * with the given parameters.
       */
      public static void log (
            )
      { 
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG)
               ).log();
      }

      /**
       * Logs the message
       * <tt>"This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}."</tt>
       * with the given parameters.
       * @param cause the Throwable that causes this message to be logged.
       */
      public static void log (Throwable cause
            )
      {
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG, cause)).log();
      }
        

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable)
      {
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS2</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: {TEST} This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParameters2
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS2</code>. */
      public static final int INT_VALUE = 1677787142;
   
      /** The parameter <code>TEST</code> for the log message text. */
      public static final String PARAM_TEST
            = "TEST";
      
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS2</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS2";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParameters2 ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS2",
               1677787142,
               
            Level.INFO,
               "{0} This error has the id {1} occured on Thread {2} named {3}. Please note that the nested exception was {4}.",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "TEST" ,  // PARAM_TEST
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE"   // PARAM__CAUSE
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @param test The test used in the message.
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String test)
      {
         loggable.addParameter(PARAM_TEST, test);
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS_LOG2</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: {TEST} This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParametersLog2
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS_LOG2</code>. */
      public static final int INT_VALUE = 1677787143;
   
      /** The parameter <code>TEST</code> for the log message text. */
      public static final String PARAM_TEST
            = "TEST";
      
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS_LOG2</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS_LOG2";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParametersLog2 ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS_LOG2",
               1677787143,
               
            Level.INFO,
               "{0} This error has the id {1} occured on Thread {2} named {3}. Please note that the nested exception was {4}.",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "TEST" ,  // PARAM_TEST
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE"   // PARAM__CAUSE
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      
      /**
       * Logs the message
       * <tt>"{TEST} This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}."</tt>
       * with the given parameters.
       * @param test The test used in the message.
       */
      public static void log (String test
            )
      { 
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG2)
               , test).log();
      }

      /**
       * Logs the message
       * <tt>"{TEST} This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}."</tt>
       * with the given parameters.
       * @param test The test used in the message.
       * @param cause the Throwable that causes this message to be logged.
       */
      public static void log (String test, Throwable cause
            )
      {
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG2, cause), test).log();
      }
        

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @param test The test used in the message.
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String test)
      {
         loggable.addParameter(PARAM_TEST, test);
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS3</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}. {TEST}</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParameters3
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS3</code>. */
      public static final int INT_VALUE = 1677787144;
   
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      
      /** The parameter <code>TEST</code> for the log message text. */
      public static final String PARAM_TEST
            = "TEST";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS3</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS3";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParameters3 ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS3",
               1677787144,
               
            Level.INFO,
               "This error has the id {0} occured on Thread {1} named {2}. Please note that the nested exception was {3}. {4}",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE" ,  // PARAM__CAUSE
                     "TEST"   // PARAM_TEST
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String test)
      {
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    Not real fun!
    * .
    * <p>This class holds the static data for the <code>IMPLIED_PARAMETERS_LOG3</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.{TEST}</li>
      
       <li>Description: Not real fun!</li>
      
    * </ul>
    */
   public static final class ImpliedParametersLog3
         extends TssLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>IMPLIED_PARAMETERS_LOG3</code>. */
      public static final int INT_VALUE = 1677787145;
   
      /** The parameter <code>_TRACKING_NUMBER</code> for the log message text. */
      public static final String PARAM__TRACKING_NUMBER
            = "_TRACKING_NUMBER";
      
      /** The parameter <code>_THREAD_ID</code> for the log message text. */
      public static final String PARAM__THREAD_ID
            = "_THREAD_ID";
      
      /** The parameter <code>_THREAD_NAME</code> for the log message text. */
      public static final String PARAM__THREAD_NAME
            = "_THREAD_NAME";
      
      /** The parameter <code>_CAUSE</code> for the log message text. */
      public static final String PARAM__CAUSE
            = "_CAUSE";
      
      /** The parameter <code>TEST</code> for the log message text. */
      public static final String PARAM_TEST
            = "TEST";
      

      /**
       * The unique symbolic String of the log message
       * <code>IMPLIED_PARAMETERS_LOG3</code>.
    
    
       * @description Not real fun!
       */
      public static final String SYMBOL
        = "TCS_TSS_IMPLIED_PARAMETERS_LOG3";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private ImpliedParametersLog3 ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "TCS_TSS_IMPLIED_PARAMETERS_LOG3",
               1677787145,
               
            Level.INFO,
               "This error has the id {0} occured on Thread {1} named {2}. Please note that the nested exception was {3}.{4}",
               "",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "_TRACKING_NUMBER" ,  // PARAM__TRACKING_NUMBER
                     "_THREAD_ID" ,  // PARAM__THREAD_ID
                     "_THREAD_NAME" ,  // PARAM__THREAD_NAME
                     "_CAUSE" ,  // PARAM__CAUSE
                     "TEST"   // PARAM_TEST
                  },
               "Testcase",
               "TCS",
               "Test Service",
               "TSS");
      }
      
      /**
       * Logs the message
       * <tt>"This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.{TEST}"</tt>
       * with the given parameters.
       */
      public static void log (String test
            )
      { 
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG3)
               , test).log();
      }

      /**
       * Logs the message
       * <tt>"This error has the id {:_TRACKING_NUMBER} occured on Thread {:_THREAD_ID} named {:_THREAD_NAME}. Please note that the nested exception was {:_CAUSE}.{TEST}"</tt>
       * with the given parameters.
       * @param cause the Throwable that causes this message to be logged.
       */
      public static void log (String test, Throwable cause
            )
      {
         addParameters(new LogEvent(IMPLIED_PARAMETERS_LOG3, cause), test).log();
      }
        

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String test)
      {
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /** The log message for the event <code>FUNNY_RUNTIME</code>. */
   public static final FunnyRuntime FUNNY_RUNTIME
         = new FunnyRuntime();

   /** The log message for the event <code>IMPLIED_PARAMETERS</code>. */
   public static final ImpliedParameters IMPLIED_PARAMETERS
         = new ImpliedParameters();

   /** The log message for the event <code>IMPLIED_PARAMETERS_LOG</code>. */
   public static final ImpliedParametersLog IMPLIED_PARAMETERS_LOG
         = new ImpliedParametersLog();

   /** The log message for the event <code>IMPLIED_PARAMETERS2</code>. */
   public static final ImpliedParameters2 IMPLIED_PARAMETERS2
         = new ImpliedParameters2();

   /** The log message for the event <code>IMPLIED_PARAMETERS_LOG2</code>. */
   public static final ImpliedParametersLog2 IMPLIED_PARAMETERS_LOG2
         = new ImpliedParametersLog2();

   /** The log message for the event <code>IMPLIED_PARAMETERS3</code>. */
   public static final ImpliedParameters3 IMPLIED_PARAMETERS3
         = new ImpliedParameters3();

   /** The log message for the event <code>IMPLIED_PARAMETERS_LOG3</code>. */
   public static final ImpliedParametersLog3 IMPLIED_PARAMETERS_LOG3
         = new ImpliedParametersLog3();


   private static final Map FROM_INT_MAP = new HashMap();
   private static final Map FROM_STRING_MAP = new HashMap();

   static
   {  
      addToMaps(FUNNY_RUNTIME);
      addToMaps(IMPLIED_PARAMETERS);
      addToMaps(IMPLIED_PARAMETERS_LOG);
      addToMaps(IMPLIED_PARAMETERS2);
      addToMaps(IMPLIED_PARAMETERS_LOG2);
      addToMaps(IMPLIED_PARAMETERS3);
      addToMaps(IMPLIED_PARAMETERS_LOG3);
   }

   private static final void addToMaps (TssLogMessage error)
   {
      FROM_INT_MAP.put(new Integer(error.toInt()), error);
      FROM_STRING_MAP.put(error.toString(), error);
   }

   /**
    * Factory method to create a TssLogMessage class from its
    * string representation.
    * @param value the string representation.
    * @return TssLogMessage class from its string representation.
    */
   public static final TssLogMessage fromString (String value)
   {
      final TssLogMessage result
            = (TssLogMessage) FROM_STRING_MAP.get(value);
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid string "
               + "representation for TssLogMessage");
      }
      return result;
   }

   /**
    * Factory method to create a TssLogMessage class from its
    * integer representation.
    * @param value the integer representation.
    * @return TssLogMessage class from its integer representation.
    */
   public static final TssLogMessage fromInt (int value)
   {
      final TssLogMessage result
            = (TssLogMessage) FROM_INT_MAP.get(new Integer(value));
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid int "
               + "representation for TssLogMessage");
      }
      return result;
   }
}

